; SpeechHub Java SpeechServer Launcher
; Independent (not dependent on TCF) version
; Author Isaac Porat based on contribution from numerous sources on the NSIS website   

; This launcher version
!define VERSION "0.1.0.0"

; Installer (this launcher) flags
; Execution level always user
RequestExecutionLevel user
SilentInstall silent
AutoCloseWindow true
ShowInstDetails nevershow

!define BRAND "SpeechHub"
!define TC_PROFILE_SpeechServer "SpeechServer"

Name "${BRAND} ${TC_PROFILE_SpeechServer}"
Caption "${BRAND} ${TC_PROFILE_SpeechServer}"
; Icon "${TC_PROFILE_SpeechServer}.ico"

; Launcher file
OutFile "${TC_PROFILE_SpeechServer}_i.exe"

; Launcher file properties
VIAddVersionKey "ProductName" "${BRAND} ${TC_PROFILE_SpeechServer}"
VIAddVersionKey "Comments" "${BRAND} Java ${TC_PROFILE_SpeechServer} launcher"
VIAddVersionKey "CompanyName" "${BRAND} contributors"
VIAddVersionKey "LegalTrademarks" "${BRAND} is a brand name of its contributors"
VIAddVersionKey "LegalCopyright" "Copyright (c) Isaac Porat and Bill Cox 2011, All right reserved"
VIAddVersionKey "FileDescription" "${BRAND} Java ${TC_PROFILE_SpeechServer} launcher"
VIAddVersionKey "FileVersion" "${VERSION}"
VIProductVersion "${VERSION}"

; Note - JRE own's 'ext' library omitted at this stage
!define EXT_DIR "-Djava.ext.dirs=lib/ext"
!define CLASSPATH ".;bin/SpeechServer_i-0.1.0.jar"
!define CLASS "sh.server.independent.SHServerIndependent"
  
!include "JREHandler.nsh"
!include "FileFunc.nsh"
!insertmacro GetParameters

Section ""
  SetOutPath $EXEDIR

${GetParameters} $1
; Try javaw assuming it is in the system path 
; Note Concurrent GC with incremental mode (computed automatically in Java 6 and 7)
StrCpy $0 '"${JAVA_EXE}" "${EXT_DIR}" "-XX:+UseConcMarkSweepGC" "-XX:+CMSIncrementalMode" "-cp" "${CLASSPATH}" "${CLASS}" $1'
; Standard GC
;StrCpy $0 '"${JAVA_EXE}" "${EXT_DIR}" "-cp" "${CLASSPATH}" "${CLASS}" $1'
ClearErrors  
Exec $0
IfErrors 0 done  
; Find JRE
  ClearErrors
Call GetJRE
 IfErrors 0 jrefound
 MessageBox MB_ICONSTOP "Cannot find appropriate Java Runtime Environment. $\n$\n Download Java from Oracle website, install and try again."
Abort
      jrefound:
      Pop $R0
; Note Concurrent GC with incremental mode (computed automatically in Java 6 and 7)
StrCpy $0 '"$R0" "${EXT_DIR}" "-XX:+UseConcMarkSweepGC" "-XX:+CMSIncrementalMode" "-cp" "${CLASSPATH}" "${CLASS}" $1'
; Standard GC
;StrCpy $0 '"$R0" "${EXT_DIR}" "-cp" "${CLASSPATH}" "${CLASS}" $1'
ClearErrors  
Exec $0
IfErrors 0 done  
MessageBox MB_ICONINFORMATION "Java launch error"
  done:  
  
  SectionEnd
