/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package core.utilities;

import java.awt.Toolkit;
import java.util.Timer;
import java.util.TimerTask;

public class Beep
{
	private static Timer fBeepTimer;
	private static boolean fBusyFlag = false;

	public static void beep()
	{
		if (fBeepTimer != null)
			fBeepTimer.cancel();
		if (fBusyFlag)
			return;
		new TimedBeep();
	}

	private static class TimedBeep
	{

		public TimedBeep()
		{
			fBeepTimer = new Timer();
			fBeepTimer.schedule(new BeepTask(), 50);
		}
	}

	private static class BeepTask extends TimerTask
	{

		public BeepTask()
		{
		}

		@Override
		public void run()
		{
			/*
			// Ignore if framework is shutting down
			if (SFrameworkShutdown.getInstance().getShuttingDownStatus())
				return;
			*/
			fBusyFlag = true;
			Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
			Toolkit.getDefaultToolkit().beep();
			fBusyFlag = false;
		}
	}

}
