/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package core.utilities;

import java.io.File;
import java.io.RandomAccessFile;
import java.nio.channels.FileLock;

import log.common.BasicLogger;

public class InstanceHandler
{

	public static boolean lockInstance(final String lockFile)
	{
		try
		{
			final File file = new File(lockFile);
			final RandomAccessFile randomAccessFile = new RandomAccessFile(file, "rw");
			final FileLock fileLock = randomAccessFile.getChannel().tryLock();
			if (fileLock != null)
			{
				Runtime.getRuntime().addShutdownHook(new Thread()
				{
					public void run()
					{
						try
						{
							fileLock.release();
							randomAccessFile.close();
							file.delete();
						} catch (Exception ex)
						{
							BasicLogger.errorPrintln("Unable to remove lock file: " + ex);
						}
					}
				});
				return true;
			}
		} catch (Exception ex)
		{
			BasicLogger.errorPrintln("Unable to create and/or lock file: " + ex);
		}
		return false;
	}

}
