/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package core.utilities;

public class OS
{

	public static String getOS()
	{
		return (getOSName());
	}

	public static boolean isWindows()
	{
		String os = getOSName().toLowerCase();
		if (os.startsWith("windows"))
			return (true);
		return (false);
	}

	public static boolean isWindows95()
	{
		String os = getOSName().toLowerCase();
		if (os.equals("windows 95"))
			return (true);
		return (false);
	}

	public static boolean isWindows98()
	{
		String os = getOSName().toLowerCase();
		if (os.equals("windows 98"))
			return (true);
		return (false);
	}

	public static boolean isWindowsME()
	{
		String os = getOSName().toLowerCase();
		if (os.equals("windows me"))
			return (true);
		return (false);
	}

	public static boolean isWindowsNT()
	{
		String os = getOSName().toLowerCase();
		if (os.equals("windows nt"))
			return (true);
		return (false);
	}

	public static boolean isWindows2000()
	{
		String os = getOSName().toLowerCase();
		if (os.equals("windows 2000"))
			return (true);
		return (false);
	}

	public static boolean isWindowsXP()
	{
		String os = getOSName().toLowerCase();
		if (os.equals("windows xp"))
			return (true);
		return (false);
	}

	public static boolean isWindowsVista()
	{
		String os = getOSName().toLowerCase();
		if (os.startsWith("windows vista"))
			return (true);
		return (false);
	}

	public static boolean isWindows7()
	{
		String os = getOSName().toLowerCase();
		if (os.startsWith("windows 7"))
			return (true);
		return (false);
	}

	public static boolean isWindows8()
	{
		String os = getOSName().toLowerCase();
		if (os.startsWith("windows 8"))
			return (true);
		return (false);
	}

	public static boolean isMac()
	{
		String os = getOSName().toLowerCase();
		if (os.startsWith("mac"))
			return (true);
		return (false);
	}

	public static boolean isLinux()
	{
		String os = getOSName().toLowerCase();
		if (os.startsWith("linux"))
			return (true);
		return (false);
	}

	public static boolean isShutdownSupported()
	{
		if ((isWindows95()) || (isWindows98()) || (isWindowsME()) || (isWindowsXP()) || (isWindowsVista()))
			/* Linux needs more work because in administrator mode shutdown is not allowed
			 * Either Talking Computer is operated in Administrator mode
			 * or possibly a special program that has administrator privilages is run
			*(isLinux())) 
			*/
			return (true);
		return (false);
	}

	public static String getOSName()
	{
		return (System.getProperty("os.name"));
	}

	public static String getJVMArchitecture()
	{
		/*
		 * Note the os.arch property specifies the JVM architecture not the OS! 
		 * As there is inconsistancy in the os.arch System property,
		 * The following is a solution which will probably work for Unix Windows and Mac
		 * not sure about Android
		 * There is an informative article about 
		 * making jni compatible across platforms:
		 * http://javablog.co.uk/2007/05/19/making-jni-cross-platform/
		 */
		String osArch = System.getProperty("os.arch");
		if (osArch.contains("64"))
			return ("64");
		return ("32");
	}

}
