/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package core.utilities;

import java.io.File;

import javax.swing.filechooser.FileSystemView;

/**
 * OS special directories
 * At present works only for Windows
 * but probably can be made to work in Linux as well
 * @author Isaac Porat
 *
 */
public class OSDir
{

	public static String getMyDocumentDirectory()
	{
		String contentDirectory = null;
		if (OS.isWindows())
		{
			FileSystemView fsv = FileSystemView.getFileSystemView();
			File contentDirectoryFile = fsv.getDefaultDirectory();
			if (contentDirectoryFile != null)
				contentDirectory = contentDirectoryFile.getAbsolutePath();
		}
		return (contentDirectory);
	}

	public static String getSettingsDirectory()
	{
		String settingsDirectory = null;
		if (OS.isWindows())
		{
			settingsDirectory = System.getenv("APPDATA");
		}
		return (settingsDirectory);
	}

}
