/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package core.utilities;

import java.util.*;
import java.io.IOException;


public class PropertiesList
{
	private List<String> keyList = new ArrayList<String>();
	private Map<String, String> propertiesMap = new HashMap<String, String>();

	public PropertiesList()
	{
	}

	public PropertiesList(String filePath) throws IOException
	{
		String string = DirFileUtilities.fileToString(filePath);
		String[] lines = string.split("[\n]+");
		for (int n = 0; n < lines.length; n++)
		{
			lines[n] = lines[n].trim();
			if (lines[n].equals(""))
				continue;
			if (lines[n].startsWith("#"))
				continue;
			if (lines[n].matches(".+=.+"))
			{
				String[] parts = lines[n].split("=");
				put(parts[0], parts[1]);
			}
		}
	}

	public void clear()
	{
		propertiesMap.clear();
		keyList.clear();
	}

	public void put(String key, String value)
	{
		propertiesMap.put(key, value);
		if (!keyList.contains(key))
			keyList.add(key);
	}

	public String get(String key)
	{
		return (propertiesMap.get(key));
	}

	public boolean containsKey(String key)
	{
		return (propertiesMap.containsKey(key));
	}

	public String[] toKeysArray()
	{
		String[] keyArray =
		{};
		return (keyList.toArray(keyArray));
	}

}
