/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package hrpc.transport;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;

public class HRPipeBridge
{
	private static HRPipeBridge fStreamBridge = null;
	private PipedInputStream fClientInputStream;
	private PipedOutputStream fClientOutputStream;
	private PipedInputStream fServerInputStream;
	private PipedOutputStream fServerOutputStream;

	private HRPipeBridge() throws IOException
	{
		fServerInputStream = new PipedInputStream();
		fClientOutputStream = new PipedOutputStream(fServerInputStream);
		fClientInputStream = new PipedInputStream();
		fServerOutputStream = new PipedOutputStream(fClientInputStream);
	}

	public synchronized static HRPipeBridge getInstance() throws IOException
	{
		if (fStreamBridge == null)
			fStreamBridge = new HRPipeBridge();
		return (fStreamBridge);
	}

	public synchronized static void destroy()
	{
		fStreamBridge = null;
	}

	public InputStream getClientInputStream()
	{
		return (fClientInputStream);
	}

	public OutputStream getClientOutputStream()
	{
		return (fClientOutputStream);
	}

	public InputStream getServerInputStream()
	{
		return (fServerInputStream);
	}

	public OutputStream getServerOutputStream()
	{
		return (fServerOutputStream);
	}

}
