/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package hrpc.transport;

import hrpc.common.HRTransportInterface;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.Socket;

public class HRTransportSocketUnixServer implements HRTransportInterface
{
	private Socket fSocket;
	private PrintStream fOut;
	private BufferedReader fIn;
	private InputStream fInRaw;
	private String fFormat;

	public HRTransportSocketUnixServer(Socket socket, String format) throws IOException
	{
		fSocket = socket;
		fFormat = format;
	}

	public BufferedReader getStdin()
	{
		return (fIn);
	}

	public InputStream getStdinRaw()
	{
		return (fInRaw);
	}

	public PrintStream getStdout()
	{
		return (fOut);
	}

	public void open() throws IOException
	{
		fInRaw = fSocket.getInputStream();
		fIn = new BufferedReader(new InputStreamReader(fInRaw, fFormat));
		fOut = new PrintStream(fSocket.getOutputStream(), true, fFormat);
	}

	public void close() throws IOException
	{
		if ((fSocket != null) && (fSocket.isClosed() == false))
			fSocket.close();
		fSocket = null;
	}

}
