/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package hrpc.transport;

import hrpc.common.HRTransportInterface;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;

public class HRTransportStdioServer implements HRTransportInterface
{
	private PrintStream fOut;
	private BufferedReader fIn;
	private InputStream fInRaw;
	private String fFormat;

	public HRTransportStdioServer(String format)
	{
		fFormat = format;
	}

	public BufferedReader getStdin()
	{
		return (fIn);
	}

	public InputStream getStdinRaw()
	{
		return (fInRaw);
	}

	public PrintStream getStdout()
	{
		return (fOut);
	}

	public void open() throws IOException
	{
		fInRaw = System.in;
		fIn = new BufferedReader(new InputStreamReader(fInRaw, fFormat));
		// Note - PrintWriter is a sub class of OutputStream so encoding can be specified 
		// although System.out is a PrintStream already
		fOut = new PrintStream(System.out, true, fFormat);
	}

	public void close() throws IOException
	{
		// It is assumed that all resources have been properly terminated by the handler
		System.exit(0);
	}

}
