/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package log.common;

import java.io.PrintStream;

/*
 * Low level log print, all logger are routed to this class
* To enable an implementation to potentially use stdout and stdin for communicationn  
 * All loggers are using STDERR and routed to errorPrintln regardless of log level
 * All information use notifyPrintln
 * All method in this class use System.err.println to make sure information is in the right order
 * Both STDOUT and STDERR are routed by default to the log.txt file by the launcher.  
 */
public class BasicLogger
{
	private static PrintStream fNotifyPrintStream = System.err;
	private static PrintStream fErrorPrintStream = System.err;

	public static void notifyPrintln(String message)
	{
		fNotifyPrintStream.println(message);
	}

	public static void notifyPrintf(String format, Object[] objects)
	{
		fNotifyPrintStream.printf(format, objects);
	}

	public static void setNotifyPrintStream(PrintStream notifyPrintStream)
	{
		fNotifyPrintStream = notifyPrintStream;
	}

	public static void errorPrintln(String message)
	{
		fErrorPrintStream.println(message);
	}

	public static void errorPrintf(String format, Object[] objects)
	{
		fErrorPrintStream.printf(format, objects);
	}

	public static void setErrorPrintStream(PrintStream errorPrintStream)
	{
		fErrorPrintStream = errorPrintStream;
	}

}
