/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.audio;

public interface SHAudioDeliveryCombinedInterface
{

	public abstract void open() throws SHAudioDeliveryException;

	public abstract void close() throws SHAudioDeliveryException;

	public abstract void start() throws SHAudioDeliveryException;

	public abstract void stop() throws SHAudioDeliveryException;

	public abstract int available();

	public abstract void write(byte[] bytes) throws SHAudioDeliveryException;

	public abstract void flush() throws SHAudioDeliveryException;

	public abstract void drain() throws SHAudioDeliveryException;

	public abstract void indicateSpeak(String message);

	public abstract void indicateCancel();

	public abstract void setTotalWritten(int totalWritten);

	public abstract int getTotalWritten();

	public abstract void setMute(boolean status);

	public abstract void setGain(float gain);

}
