/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.audio;

import log.common.CascadingLoggerInterface;
import sh.connections.SHMessageEnvelopeInterface;
import sh.connections.SHAudioDataHandlerInterface;

/**
 * Directs audio data to audio handler plugin
 * using the message envelope
 * 
 * @author Isaac Porat
 *
 */
public class SHAudioDeliveryParallelAudioHandlerPlugin implements SHAudioDeliveryParallelInterface
{
	private CascadingLoggerInterface log;
	private SHAudioDataHandlerInterface fAudioDataHandler;

	public SHAudioDeliveryParallelAudioHandlerPlugin(SHAudioDataHandlerInterface audioDataHandler,
			CascadingLoggerInterface logger)
	{
		log = logger.clone(SHAudioDeliveryParallelAudioHandlerPlugin.class);
		fAudioDataHandler = audioDataHandler;
	}

	@Override
	public void close() throws SHAudioDeliveryException
	{
		// Unused
	}

	@Override
	public void start() throws SHAudioDeliveryException
	{
		// Unused
	}

	@Override
	public void stop() throws SHAudioDeliveryException
	{
		// Unused	
	}

	@Override
	public void flush()
	{
		// Unused
	}

	@Override
	public void disableCatchupMode()
	{
		// Unused
	}

	@Override
	public boolean getCatchupMode()
	{
		// Unused
		return (false);
	}

	@Override
	public boolean playAudioData(SHMessageEnvelopeInterface messageEnvelope)
	{
		try
		{
			return (fAudioDataHandler.processAudio(messageEnvelope));
		} catch (Exception ex)
		{
			log.error("Error in playAudioData method:\n" + ex);
			return (false);
		}
	}

	@Override
	public void cancel()
	{
		// Unused
	}

	@Override
	public void drain()
	{
		// Unused
	}

	@Override
	public void setMute(boolean status)
	{
		// Unused
	}

	@Override
	public void setGain(float gain)
	{
		// Unused
	}

}
