/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.audio;

import sh.connections.SHMessageEnvelopeInterface;

public interface SHAudioDeliveryParallelInterface
{

	public abstract void close() throws SHAudioDeliveryException;

	public abstract void start() throws SHAudioDeliveryException;

	public abstract void stop() throws SHAudioDeliveryException;

	public abstract void flush() throws SHAudioDeliveryException;

	public abstract void drain() throws SHAudioDeliveryException;

	public abstract void disableCatchupMode();

	public abstract boolean getCatchupMode();

	public abstract boolean playAudioData(SHMessageEnvelopeInterface messageEnvelope);

	public abstract void cancel();

	public abstract void setMute(boolean status);

	public abstract void setGain(float gain);

}
