/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.common;

import sh.connections.SHMethodEnvelopeInterface;
import sh.connections.SHConstants;
import sh.connections.SHAudioDataHandlerInterface;
import sh.connections.SHEventsListenerInterface;
import sh.connections.SHUpdateParametersInterface;

public class SHMethodEnvelope implements SHMethodEnvelopeInterface
{
	private SHConstants.MethodName fCommandType = SHConstants.MethodName.SPEAK;
	private float fArgFloat = 0;
	private String fArgString1;
	private String fArgString2;
	private SHUpdateParametersInterface fUpdateParametersDirectly;
	private SHEventsListenerInterface fEventsListener;
	private SHAudioDataHandlerInterface fAudioDataHandler;

	public void setCommandType(SHConstants.MethodName commandType)
	{
		fCommandType = commandType;
	}

	public SHConstants.MethodName getCommandType()
	{
		return (fCommandType);
	}

	public void setArgFloat(float argFloat)
	{
		fArgFloat = argFloat;
	}

	public float getArgFloat()
	{
		return (fArgFloat);
	}

	public void setArgString1(String argString)
	{
		fArgString1 = argString;
	}

	public String getArgString1()
	{
		return (fArgString1);
	}

	public void setArgString2(String argString)
	{
		fArgString2 = argString;
	}

	public String getArgString2()
	{
		return (fArgString2);
	}

	public void setUpdateParametersDirectly(SHUpdateParametersInterface updateParameters)
	{
		fUpdateParametersDirectly = updateParameters;
	}

	public SHUpdateParametersInterface getUpdateParametersDirectly()
	{
		return (fUpdateParametersDirectly);
	}

	public void setEventsListener(SHEventsListenerInterface eventsListener)
	{
		fEventsListener = eventsListener;
	}

	public SHEventsListenerInterface getEventsListener()
	{
		return (fEventsListener);
	}

	public void setAudioDataHandler(SHAudioDataHandlerInterface audioDataHandler)
	{
		fAudioDataHandler = audioDataHandler;
	}

	public SHAudioDataHandlerInterface getAudioDataHandler()
	{
		return (fAudioDataHandler);
	}

}
