/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.connections;

public interface SHAudioDataHandlerInterface
{

	/**
	 * This method is optionally called by the engine to process audio samples before dispatch to the audio system
	 * @param samples audio bytes to process
	* @return  true during normal operation, 
	* false if the user has canceled playback, so the synthesizer can stop.
	 	 	 */
	public boolean processAudio(byte[] samples);

	/**
	 * This method is optionally called by the module to process audio samples before dispatch to the audio system
	 * @param messageEnvelope containing audio data and metadata to process
	* @return  true during normal operation, 
	* false if the user has canceled playback, so the synthesizer can stop.
	 	 	 */
	public boolean processAudio(SHMessageEnvelopeInterface messageEnvelope);

}
