/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.connections;

import java.util.Set;

import sh.audio.SHAudioSpeechCache;

public interface SHAudioSpeechPlayerInterface
{

	public abstract boolean setAudioDataHandler(SHAudioDataHandlerInterface ttsAudioDataHandler);

	public abstract void setConnectorEngineSet(Set<String> connectorEngineSet);

	public abstract void setMessagePeekHandler(SHMessageQueuePeekHandlerInterface messagePeekHandler);

	public abstract boolean initialize(SHModuleInterface module, SHAudioSpeechCache audioSpeechCache);
		
	public abstract boolean close();

	public abstract boolean notifyEngineChanged(String engineIdentifier);

	public abstract boolean speak(SHMessageEnvelopeInterface messageEnvelope);

	public abstract boolean cancel();

	public abstract boolean pause();

	public abstract boolean resume();

	public abstract boolean setVolume(float volume);

	public abstract boolean isPlayerHandlesRate();

	public abstract boolean setRate(float rate);

	public abstract boolean isPlayerHandlesPitch();

	public abstract boolean setPitch(float pitch);

	public abstract boolean setClientUseSonic(boolean mode);

}
