/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.connections;

/**
 * Parameters associated with every server client
 * @author Isaac Porat
 *
 */
public interface SHClientParametersInterface
{
	/**
	 * @return a clone of SHUpdateParameters object
	 */
	public SHUpdateParametersInterface getClonedUpdateParameters();

	public String getClientIdentifier();

	public String getClientIdentifierCaption();

	public void setClientIdentifierCaption(String clientIdentifierCaption);

	public SHModuleTimestampInterface getModuleTimestamp();

	public void setModuleTimestamp(SHModuleTimestampInterface moduleTimestamp);

	public SHEventsListenerInterface getEventsListener();

	public void setEventsListener(SHEventsListenerInterface eventsListener);

	public SHAudioDataHandlerInterface getAudioDataHandler();

	public void setAudioDataHandler(SHAudioDataHandlerInterface audioDataHandler);

	public void setEngineIdentifier(String engineIdentifier);

	public String getEngineIdentifier();

	public void setLanguageCode(String languageCode);

	public String getLanguageCode();

	public void setVoiceIdentifier(String voiceIdentifier);

	public String getVoiceIdentifier();

	public void setVariantIdentifier(String variantIdentifier);

	public String getVariantIdentifier();

	public void setVolume(float volume);

	public float getVolume();

	public void setRate(float rate);

	public float getRate();

	public void setPitch(float pitch);

	public float getPitch();

	public void setProperty(String key, String value);

	public String getProperty(String key);

	public boolean isPropertiesUpdateRequired();

	public void resetPropertiesUpdateRequired();

}
