/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.connections;

import java.util.Date;

import sh.connections.SHConstants.CapitalIndicator;
import sh.connections.SHConstants.MessageAudioFeedState;
import sh.connections.SHConstants.MessageState;
import sh.connections.SHConstants.MessageTextToAudioConversionState;
import sh.connections.SHConstants.MessageType;

public interface SHMessageEnvelopeInterface extends SHMethodEnvelopeInterface
{

	public int getMessageIdentifier();

	public String getClientIdentifier();

	public void setClientIdentifier(String clientIdentifier);

	public int getMessageFragmentIdentifier();

	public void setMessageFragmentIdentifier(int messageFragmentIdentifier);

	public Date getTimestamp();

	public void setTimestamp(Date timestamp);

	public boolean getMessageSynchronized();

	public void setMessageSynchronized(boolean messageSynchronized);

	public MessageState getMessageState();

	public void setMessageState(MessageState messageState);

	public MessageType getMessageType();

	public void setMessageType(MessageType messageType);

	public CapitalIndicator getCapitalIndicator();

	public void setCapitalIndicator(CapitalIndicator capitalIndicator);

	public int getPriorityLevel();

	public void setPriorityLevel(int priorityLevel);

	public boolean getSelfCancel();

	public void setSelfCancel(boolean selfCancel);

	public SHUpdateParametersInterface getUpdateParameters();

	public void setUpdateParameters(SHUpdateParametersInterface updateParameters);

	public String getMessage();

	public void setMessage(String message);

	public void setSilenceBeforeMessage(int silenceMilliseconds);

	public int getSilenceBeforeMessage();

	public String toString();

	public void initializeAudio();

	public int getAudioSampleRate();

	public void setAudioSampleRate(int audioSampleRate);

	public float getTrailingSilenceTrimRatio();

	public void setTrailingSilenceTrimRatio(float trailingSilenceTrimRatio);

	public void setTotalAudioWritten(int totalWritten);

	public int getTotalAudioWritten();

	public void setAudioCacheUsed(boolean audioCacheUsed);

	public boolean getAudioCacheUsed();

	public void setMessageTextToAudioConversionState(MessageTextToAudioConversionState messageTextToAudioConversionState);

	public MessageTextToAudioConversionState getMessageTextToAudioConversionState();

	public MessageAudioFeedState getMessageAudioFeedState();

	public void putAudio(byte[] bytes) throws InterruptedException;

	public byte[] takeAudio() throws InterruptedException;

	public void clearAudio();

	public boolean isEmptyAudio();

	public boolean waitForMessageAudio() throws InterruptedException;

}
