/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.connector.freeTTS;

import hrpc.common.HRMessageHandlerJSONInterface;
import hrpc.common.HRSenderHandlerJSONInterface;
import hrpc.sh.client.SHEngineConnectorClientBase;

import java.io.IOException;

import log.common.CascadingLoggerInterface;
import sh.connections.SHCustomeHandlersInterface;

public class SHConnectorFreeTTSClientAdaptor extends SHEngineConnectorClientBase
{
	private boolean fInitialized = false;

	public SHConnectorFreeTTSClientAdaptor(HRMessageHandlerJSONInterface messageHandler,
			HRSenderHandlerJSONInterface senderHandler, CascadingLoggerInterface logger) throws IOException
	{
		log = logger.clone(SHEngineConnectorClientBase.class);
		fMessageHandler = messageHandler;
		fSenderHandler = senderHandler;
	}

	@Override
	public boolean initialize()
	{
		if (fInitialized == false)
			fInitialized = super.initialize();
		return (fInitialized);
	}

	@Override
	public boolean close()
	{
		if (fInitialized == false)
			return (true);
		boolean status = super.close();
		if (status)
			fInitialized = false;
		return (status);
	}

	@Override
	public boolean selectEngine(String engineIdentifier)
	{
		checkEngine();
		return (super.selectEngine(engineIdentifier));
	}

	@Override
	public String getProperty(String key)
	{
		checkEngine();
		return (super.getProperty(key));
	}

	@Override
	public boolean setProperty(String key, String value)
	{
		// Not implemented
		return (false);
	}

	@Override
	public void checkEngine()
	{
		if (fInitialized == false)
			fInitialized = initialize();
	}

	@Override
	public boolean setCustomeHandlers(SHCustomeHandlersInterface customHandler)
	{
		// Not implemented
		return (false);
	}
}
