/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.dev.test;

import java.io.File;

import core.utilities.StackTrace;

import log.common.CascadingLoggerInterface;
import log.common.SimpleLogger;
import sh.connections.SHConstants;
import sh.independent.SHConfigIndependent;
import sh.server.SHServerLauncher;
import sh.server.independent.SHServerIndependent;

/**
 * Launches  the server with multi type engines connector
 * Multi type  engine  connector provides multiple engines
 * in a single module without using the OSGi framework 
 */
public class SHIndependentServerTest
{
	@SuppressWarnings("unused")
	private static SHServerLauncher fServerLauncher;

	public static void main(String[] args)
	{
		/*
		* Log levels 
		* Error - 1
		* Warning - 2
		* Info - 3
		* Debug - 4
		*/
		int logLevel = 2;
		CascadingLoggerInterface log = new SimpleLogger(SHServerIndependent.class, logLevel);

		try
		{
			// Configure locations - settings and  engines
			SHConfigIndependent.configureLocations(log);

			log.notify("Independent server current directory:");
			log.notify((new File(".").getAbsolutePath()));

			SHServerIndependent multiEngineServer = new SHServerIndependent(log);
			multiEngineServer.startServer(SHConstants.SERVER_TRANSPORT_MULTI_SOCKET_INET, 0);
		} catch (Exception ex)
		{
			log.error("Error in main method:\n" + StackTrace.stackToString(ex));
		}
	}

}
