/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.server.transport;

import hrpc.common.HRHandlerInterface;
import hrpc.common.HRMessageHandlerInterface;
import hrpc.common.HRTransportInterface;
import hrpc.handler.HRMessageHandlerServer;
import hrpc.transport.HRTransportStdioServer;

import java.io.IOException;

import log.common.CascadingLoggerInterface;

import sh.common.SHConfig;
import sh.connections.SHConstants;
import sh.server.essip.SHExtendedSSIPHandler;

public class SHMainServerStdio
{
	private CascadingLoggerInterface log;
	private boolean fDebugMode = false;

	public SHMainServerStdio(CascadingLoggerInterface logger) throws IOException
	{
		log = logger.clone(SHMainServerStdio.class);
		String value = SHConfig.getServerProperty(SHConstants.PROP_SERVER_DEBUG_MODE);
		fDebugMode = ((value != null) && (value.equalsIgnoreCase("true")));
		HRHandlerInterface handler = new SHExtendedSSIPHandler(fDebugMode, log);
		HRTransportInterface serverTransport = new HRTransportStdioServer("UTF-8");
		HRMessageHandlerInterface messageHandler = new HRMessageHandlerServer(handler, false, fDebugMode, log);
		messageHandler.setTransport(serverTransport);
		messageHandler.open();
	}

}
