/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.services;

import sh.connections.SHModuleInterface;

public interface SHTTSModulesControllerServiceInterface
{

	/**
	 * Get TTS engine identifiers
	 * @return engine identifiers array.
	 */
	public String[] getTTSEngineIdentifiers();

	/**
	 * Select TTS module 
	 * 
	 * @param engineIdentifier Identify the module required
	 * @return true if successfull false if not.
	 */
	public boolean selectTTSModule(String engineIdentifier);

	/**
	 * getSelectedTTSEngineIdentifier
	 *  
	 * @return Selected TTS engine identifier
	 */
	public String getSelectedTTSModuleEngineIdentifier();

	/**
	 * getSelectedTTSModule
	 *  
	 * @return Selected  TTS module
	 */
	public SHModuleInterface getSelectedTTSModule();

}
