/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.settings;

import java.io.IOException;

import sh.connections.SHModuleInterface;

public class SHModuleConfiguration
{

	public SHModuleConfiguration()
	{
	}

	public void loadProperties(SHEnhancedPropertiesList enhancedPropertiesList, String filePath) throws IOException
	{
		SHEnhancedPropertiesList propertiesList = new SHEnhancedPropertiesList(filePath);
		String[] keysArray = propertiesList.toKeysArray();
		for (int n = 0; n < keysArray.length; n++)
		{
			String key = keysArray[n];
			String value = propertiesList.get(keysArray[n]);
			enhancedPropertiesList.put(key, value);
		}
	}

	public void transferPropertiesToModule(SHModuleInterface module, SHEnhancedPropertiesList propertiesList)
	{
		String[] keysArray = propertiesList.toKeysArray();
		String key, value;
		for (int n = 0; n < keysArray.length; n++)
		{
			key = keysArray[n];
			value = propertiesList.get(key);
			module.setProperty(key, value);
		}

	}

}
