/*
* Copyright (c) Isaac Porat 2011 - 2013 all rights reserved.
* This file is released under the GNU General Public License, version 2, or (at your option) any later version.
* See the file SpeechHub_License.txt for more details.
*/

package sh.tc;

import log.common.CascadingLoggerInterface;
import sh.common.SHConfig;
import sh.settings.SHSettingsDirectoriesHandler;

/**
 * SpeechHub configuration for TC version (using OSGi)
 * @author Isaac Porat
 *
 */
public class SHConfigServerTC
{

	// Properties

	// R only
	public final static String PROP_TC_SPEECH_HUB_PARENT_DIR_R = "tc.sh.dir";
	// Read and Write
	public final static String PROP_TC_SPEECH_HUB_PARENT_DIR_RW = "tc.sh.dir.read.write";

	// Locations

	public final static String TC_SETTINGS_DIR_NAME_R = "data";
	public final static String TC_SETTINGS_DIR_NAME_RW = "sh";
	public final static String TC_ENGINES_DIR_NAME_R = "";

	private static boolean fConfiguredAlready = false;

	public static void configureLocations(String settingsParentDirectoryR, String settingsParentDirectoryRW,
			String enginesParentDirectoryR, CascadingLoggerInterface logger)
	{
		if (fConfiguredAlready)
			return;
		fConfiguredAlready = true;

		SHConfig.configureSettingsLocations(settingsParentDirectoryR, TC_SETTINGS_DIR_NAME_R);
		SHConfig.configureEnginesLocations(enginesParentDirectoryR, TC_ENGINES_DIR_NAME_R);
		String settingsBaseDirectoryR = SHConfig.getSettingsBaseDirectory();

		SHConfig.configureSettingsLocations(settingsParentDirectoryRW, TC_SETTINGS_DIR_NAME_RW);
		String settingsBaseDirectoryRW = SHConfig.getSettingsBaseDirectory();

		SHSettingsDirectoriesHandler.getInstance(logger).verifySettingsDirectories(settingsBaseDirectoryR,
				settingsBaseDirectoryRW);
	}

}
